<?php
/**
 * Created by PhpStorm.
 * User: steve
 * Date: 23/08/18
 * Time: 09:37
 */

namespace Drupal\event_scheduler\Event;

/**
 * Interface EventScheduleInterface
 *
 * @package Drupal\event_scheduler\Event
 */
interface EventScheduleInterface {

  /**
   * Initialise the launch time and tag for this event.
   *
   * @param int $launch
   * @param string $tag
   *
   * @return EventScheduleInterface
   */
  public function initialise(int $launch, string $tag = ''): EventScheduleInterface;

  /**
   * @param int $id
   *
   * @return $this
   */
  public function setId(int $id): EventScheduleInterface;

  /**
   * @return int
   */
  public function id(): int;

  /**
   * @param string $name
   *
   * @return $this
   */
  public function setName(string $name): EventScheduleInterface;

  /**
   * @return string
   */
  public function getName(): string;

  /**
   * @param string $event_class
   *
   * @return $this
   */
  public function setClass(string $event_class): EventScheduleInterface;

  /**
   * @return string
   */
  public function getClass(): string;

  /**
   * @param string $tag
   *
   * @return $this
   */
  public function setTag(string $tag): EventScheduleInterface;

  /**
   * @return string
   */
  public function getTag(): string;

  /**
   * @param int $when UTC timestamp
   *
   * @return $this
   */
  public function setLaunch(int $when): EventScheduleInterface;

  /**
   * @return int UTC timestamp
   */
  public function getLaunch(): int;

  /**
   * @param bool
   *
   * @return $this
   */
  public function setProcessed(bool $processed = TRUE): EventScheduleInterface;

  /**
   * @return bool
   */
  public function getProcessed(): bool;

}
