<?php

namespace Drupal\event_scheduler;

use Drupal\event_scheduler\Event\EventScheduleInterface;

/**
 * Interface EventSchedulerInterface
 *
 * @package Drupal\event_scheduler
 */
interface EventSchedulerInterface {

  /**
   * @param EventScheduleInterface $event
   * @param string $eventName
   */
  public function saveEvent(EventScheduleInterface $event, string $eventName);

  /**
   * Extract the matching events from the DB, unserializing the event structure.
   *
   * @param array $conditions
   *
   * @param bool $firstOnly
   *
   * @return EventScheduleInterface[] | EventScheduleInterface
   *
   */
  public function loadEvent(array $conditions = [], bool $firstOnly = FALSE);

  /**
   * Delete the matching events from the DB.
   *
   * @param array $conditions
   *
   */
  public function deleteEvent(array $conditions = []);

  /**
   * @return EventSchedulerDatabase
   */
  public function getDatabase(): EventSchedulerDatabase;


}
