<?php

namespace Drupal\event_scheduler;

use Symfony\Contracts\EventDispatcher\Event as EventInterface;

/**
 * Interface LocalEventQueueInterface.
 */
interface LocalEventQueueInterface {

  /**
   * Add an event to the queue
   *
   * @param EventInterface $event
   * @param string $eventName
   */
  public function add(EventInterface $event, string $eventName);

  /**
   * Returns the queued events as long as there are events to return.
   *
   * @return \Generator
   */
  public function get();


}
